#ifndef MARCHING_CUBE_H
#define MARCHING_CUBE_H

// classes de points 3D dont les coords sont des integer !!!
class Point3D
{
public:
   int x, y, z;
   Point3D(int x = 0, int y = 0, int z = 0)
   { this->x = x; this->y = y; this->z = z; return; }
};

class dPoint3D
{
public:
   double x, y, z;
   dPoint3D(double x = 0.0, double y = 0.0, double z = 0.0)
   { this->x = x; this->y = y; this->z = z; return; }
};


class Potential_Field
{
public:
	Potential_Field(int size) { Size=size;};
	virtual double Get_Potential( Point3D p) =0;
	dPoint3D Interpolate(double isolevel, Point3D p1, Point3D p2);
	int Get_Size() { return Size;};
protected :
	int Size;
};

// dessine l'isosurface iso, cad l'enveloppe des regions dont le potentiel est superieur a la valeur iso
// Potential_Field * field : le champ de potential etudi
// int step : la precision de l'isosurface, la taille du champ doit etre un multiple de step !!!
void Draw_Iso_Surface( Potential_Field * field  , double iso , int step);
void Draw_Iso_Surface_Around_Point( Potential_Field * field  , double isolevel , int step , int x,int y,int z);
void Marching_Cube_Begin( Potential_Field * field , int step);
void Marching_Cube_End( );

#endif
